﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace ifgOutLookBarBug
{
    abstract class tvvBase : INotifyPropertyChanged
    {
        protected virtual void Changed(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        public ObservableCollection<tvvBase> Childern { get; set; }


        public tvvBase()
        {
            if (this is tvvDummy)
            {

            }
            else
            {
                this.Childern = new ObservableCollection<tvvBase>();
                this.Childern.Add(new tvvDummy());
            }

        }

        private bool _hasChildern;
        public bool HasChildern
        {
            get
            {
                return _hasChildern;
            }
            set
            {
                if (_hasChildern != value)
                {
                    _hasChildern = value;
                    if (value == false)
                    {
                        this.Childern.Clear();
                    }
                    Changed("HasChildern");
                }
            }
        }
        
        public bool HasDummyChild
        {
            get
            {
                return (this.Childern.Count == 1 && this.Childern[0] is tvvDummy);
            }            
        }

        private bool _isExpanded;
        public bool IsExpanded
        {
            get
            {
                return _isExpanded;
            }
            set
            {
                if (_isExpanded != value)
                {
                    if (this.HasDummyChild)
                    {
                        this.Childern.Clear();
                        LoadContentFromServer();
                    }
                    _isExpanded = value;
                    Changed("IsExpanded");
                }
            }
        }

        private bool _isSelected;
        public bool IsSelected
        {
            get
            {
                return _isSelected;
            }
            set
            {
                if (_isSelected != value)
                {
                    _isSelected = value;
                    Changed("IsSelected");
                }
            }
        }
        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region IEfcServerLoadable Members

        public abstract void LoadContentFromServer();       

        #endregion
    }
}
