﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Threading;

namespace ifgOutLookBarBug
{
    /// <summary>
    /// Interaction logic for ucTreeView.xaml
    /// </summary>
    public partial class ucTreeView : UserControl
    {
        ObservableCollection<tvvBase> FolderCollection { get; set; }

        public ucTreeView()
        {
            InitializeComponent();
            FolderCollection = new ObservableCollection<tvvBase>();
            this.Dispatcher.BeginInvoke(DispatcherPriority.Background,
                new EventHandler(this.LoadLvlOne),
                this, new EventArgs { });

            this.FolderCollection.Add(new tvvDummy());

            this.treeViewCabinetAndFolders.ItemsSource = this.FolderCollection;  
        }

        private void LoadLvlOne(object sender, EventArgs e)
        {
            this.FolderCollection.Clear();
            List<tvvLvlOne> temp = new List<tvvLvlOne>();
            temp.Add(new tvvLvlOne { DisplayName = "Test 01" });
            temp.Add(new tvvLvlOne { DisplayName = "Test 02" });
            temp.Add(new tvvLvlOne { DisplayName = "Test 03" });
            temp.Add(new tvvLvlOne { DisplayName = "Test 04" });
            temp.ForEach(c => this.FolderCollection.Add(c));
        }

    }
}
